#!/usr/local/bin/perl
# -----------------------------------------------------------------------------
# cc2c.pl
#   c を c++ っぽくかくためのスクリプト.
# -----------------------------------------------------------------------------
# ./cc2c.pl infile.cc > outfile.c
# -----------------------------------------------------------------------------
# Mastering programed by YAMASHINA Hio
#
# Copyright 2002 YMIRLINK,Inc.
# -----------------------------------------------------------------------------
# $Id: cc2c.pl,v 1.3 2002/11/20 03:02:28 hio Exp $
# -----------------------------------------------------------------------------
# var->method(args) を Class_method(var,args) って書き換える.
# " に続く var は変換しない. (""内は変換しないの擬似対応)
# -----------------------------------------------------------------------------
package Cc2c;

use strict;

# 変換する変数
my %VARMAP = ( proxy    => 'RishuProxy',
	       response => 'RishuProxy_Response',
	       request  => 'RishuProxy_Request',
	       );
my $vars = join('|',keys %VARMAP);

my $infile = join(',',@ARGV)||'(stdin)';
print "/* this file was auto-generated by cc2c.pl from $infile */\n";
while(<>)
{
  /`/;
  s/([^"]\s*)($vars)->([a-zA-Z]\w*)\((\s*\))?/"$1$VARMAP{$2}_$3($2".($4||',')/goe;
  /`/;
  print;
}
